<!doctype html>
<html>
<head>
    <title>Stem Release 1.0 | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Stem Release 1.0 | Tor Project">
    <meta property="og:description" content="Hi all. After eighteen months of work and a number of delays rivaling that of the Big Dig I&#39;m...">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/stem-release-10/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Stem Release 1.0
      </h1>
    <p class="meta">by atagar | March 31, 2013</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>Hi all. After eighteen months of work and a number of delays rivaling that of the Big Dig I'm pleased to announce the initial release of stem!</p>

<p>For those who aren't familiar with it, stem is a python controller library for tor. With it you can write scripts and applications that interact with your tor client or relay. For some examples of what you can do see the tutorials on...</p>

<p><b><a href="https://stem.torproject.org/" rel="nofollow">https://stem.torproject.org/</a></b></p>

<p>Stem is compatible with python 2.6 and higher (including the 3.x series), and is a near complete implementation of tor's control and directory specifications. It has relatively high test coverage (~80% for most modules) and integration tests to check its continued interoperability with new releases of tor.</p>

<p>As always, if you encounter issues or have feature requests then please <a href="http://www.atagar.com/contact/" rel="nofollow">let me know</a>! Also, if you write something that uses stem then please tell me, both so we can continue to improve our API and expand the tutorial's list of examples.</p>

<p>Many thanks to everyone that helped make this initial release of stem possible, both with its development and packaging! -Damian</p>

    </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-19432"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-19432" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">March 31, 2013</p>
    </div>
    <a href="#comment-19432">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-19432" class="permalink" rel="bookmark">AWESOME! GREAT! THANK YOU SO</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>AWESOME! GREAT! THANK YOU SO MUCH!!!!!!!!!!!!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-19442"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-19442" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 01, 2013</p>
    </div>
    <a href="#comment-19442">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-19442" class="permalink" rel="bookmark">I wish I was conversant in</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I wish I was conversant in geek-speak but I'm sure whatever it is, it's jolly good. Can I buy naughty things off the internet with it?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-19444"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-19444" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 02, 2013</p>
    </div>
    <a href="#comment-19444">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-19444" class="permalink" rel="bookmark">Error providing download</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Error providing download from git repository with:<br />
git clone <a href="https://git.torproject.org/stem.git" rel="nofollow">https://git.torproject.org/stem.git</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-19445"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-19445" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  phw
  <div class="field field--name-field-display-name field--type-string field--label-visually_hidden">
    <div class="field--label sr-only">Display Name</div>
              <div class="field--item">Philipp Winter</div>
          </div>
</article>
    <div class="comment-header">
      <p class="comment__submitted"><a class="tor" title="View user profile." href="/user/46">Philipp Winter</a> said:</p>
      <p class="date-time">April 02, 2013</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-19444" class="permalink" rel="bookmark">Error providing download</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-19445">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-19445" class="permalink" rel="bookmark">What is the error message?</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>What is the error message? The exact same command works for me.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-19455"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-19455" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 03, 2013</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-19445" class="permalink" rel="bookmark">What is the error message?</a> by <a class="tor" title="View user profile." href="/user/46">Philipp Winter</a></p>
    <a href="#comment-19455">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-19455" class="permalink" rel="bookmark">Cloning into stem...
error: </a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Cloning into stem...<br />
error:  while accessing <a href="https://git.torproject.org/stem.git/info/refs" rel="nofollow">https://git.torproject.org/stem.git/info/refs</a></p>
<p>fatal: HTTP request failed</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-19456"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-19456" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 03, 2013</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-19445" class="permalink" rel="bookmark">What is the error message?</a> by <a class="tor" title="View user profile." href="/user/46">Philipp Winter</a></p>
    <a href="#comment-19456">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-19456" class="permalink" rel="bookmark">Done: changed https with</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Done: changed https with git<br />
git clone git://git.torproject.org/stem.git</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div><a id="comment-19459"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-19459" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 03, 2013</p>
    </div>
    <a href="#comment-19459">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-19459" class="permalink" rel="bookmark">Hi, is it safe to attach</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi, is it safe to attach files or pictures to an email you are sending from a webmail client? Or can the attaching of files to an email (through tor) lead to revealing of your IP to the webmail server (such as gmail?)</p>
<p>When you attach a file to an email, the little windows explorer opens up and you look through your computer to find the file. Gmail then spends a couple of seconds uploading the file to the actual email. Can this uploading of a file to an email reveal identity? Or does this uploading (attaching files to an email) also happen through the tor network and is 100% safe?</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
